// TorqueControlDlg.cpp : @
//

#include "stdafx.h"
#include "TorqueControl.h"
#include "TorqueControlDlg.h"

#include "CPMotorAPI.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CTorqueControlDlg ܤ

CTorqueControlDlg::CTorqueControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTorqueControlDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTorqueControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_SLOT, combo_slot);
	DDX_Control(pDX, IDC_COMBO_BAUD, combo_baud);
	DDX_Control(pDX, IDC_COMBO_MOTORTYPE, combo_motortype);
	DDX_Control(pDX, IDC_COMBO_MOTORID, combo_motorid);
	DDX_Control(pDX, IDC_BUTTON_INIT, btn_initial);
	DDX_Control(pDX, IDC_SLIDER_WPOSI, slider_writepos);
	DDX_Control(pDX, IDC_SLIDER_RPOSI, slider_readpos);
	DDX_Control(pDX, IDC_EDIT_WPOSI, edit_writepos);
	DDX_Control(pDX, IDC_EDIT_RPOSI, edit_readpos);
}

BEGIN_MESSAGE_MAP(CTorqueControlDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
//	ON_NOTIFY(NM_CUSTOMDRAW, IDC_SLIDER_RPOSI, &CTorqueControlDlg::OnNMCustomdrawSliderRposi)
ON_WM_DESTROY()
ON_BN_CLICKED(IDC_BUTTON_INIT, &CTorqueControlDlg::OnBnClickedButtonInit)
ON_WM_TIMER()
ON_WM_HSCROLL()
END_MESSAGE_MAP()


// CTorqueControlDlg TBz`
CString MsgStr;
BYTE Slot, Baud, Id, Type;

BOOL CTorqueControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ]wܤϥܡCε{DOܤɡA
	// ج[|۰ʱqƦ@~
	SetIcon(m_hIcon, TRUE);			// ]wjϥ
	SetIcon(m_hIcon, FALSE);		// ]wpϥ

	// TODO: b[JB~l]w
	
	WORD i;
	CString id;

	combo_slot.SetCurSel(0);
	combo_baud.SetCurSel(5);

	for(i=1; i<128; i++){
		id.Format(_T("  %03d"),i);
		combo_motorid.AddString(id);
	}
	combo_motorid.SetCurSel(0);

	combo_motortype.AddString(_T("General CiA 402 Motor"));
	combo_motortype.AddString(_T("Delta ASDA-A2 Motor"));
	combo_motortype.AddString(_T("SANYO R2 Motor"));
	combo_motortype.AddString(_T("Schneider LXM23A Motor"));
	combo_motortype.AddString(_T("FESTO CMMS-ST/CMMP-AS Motor"));
	combo_motortype.SetCurSel(1);

	slider_writepos.SetRange(-100,100,FALSE);	
	slider_writepos.SetTicFreq(5);	
	slider_writepos.SetTic(0);
	edit_writepos.SetWindowTextW(_T("0"));

	slider_readpos.SetRange(-100,100,FALSE);
	slider_readpos.SetTicFreq(5);
	slider_readpos.SetTic(0);
	edit_readpos.SetWindowTextW(_T("0"));

	return TRUE;  // Ǧ^ TRUEADzﱱ]wJI
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CTorqueControlDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_TORQUECONTROL_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_TORQUECONTROL_DIALOG));
	}
}
#endif



void CTorqueControlDlg::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: b[JzTBz`{X
	WORD ret;

	ret = CPMotor_MotionStop(Slot, Id, 300);
	if(ret != 0){
		MsgStr.Format(_T("CPMotor_MotionStop Error %d"), ret);
		MessageBox(MsgStr);
	}
	else{
		ret = CPMotor_CloseMotor(Slot, Id);
		if(ret != 0){
			MsgStr.Format(_T("CPMotor_CloseMotor Error %d"), ret);
			MessageBox(MsgStr);
		}
		else{
			ret = CPMotor_ShutdownMaster(Slot);
			if(ret != 0){
				MsgStr.Format(_T("CPMotor_ShutdownMaster Error %d"), ret);
				MessageBox(MsgStr);
			}
		}
	}
}

void CTorqueControlDlg::OnBnClickedButtonInit()
{
	// TODO: b[JiBz`{X
	WORD ret;
	
	Slot = (BYTE)combo_slot.GetCurSel();
	Baud = (BYTE)combo_baud.GetCurSel();
	Id = (BYTE)(combo_motorid.GetCurSel() + 1);
	Type = (BYTE)combo_motortype.GetCurSel();

	// CPMotor_InitMaster
	ret = CPMotor_InitMaster(MASTER_MODULE_I8123W, Slot, Baud);
    if(ret != 0){
		MsgStr.Format(_T("CPMotor_InitMaster Error %d"), ret);
		MessageBox(MsgStr);
	}
	else{
		// CPMotor_AddMotor
		ret = CPMotor_AddMotor(Slot, Id, 1, 200, Type);
		if(ret != 0){
			MsgStr.Format(_T("CPMotor_AddMotor Error %d"), ret);
			MessageBox(MsgStr);
		}
        else{
			ret = CPMotor_InitMotor(Slot, Id, 100);
			if(ret != 0){
				MsgStr.Format(_T("CPMotor_InitMotor Error %d"), ret);
				MessageBox(MsgStr);
			}
			else{
				MsgStr.Format(_T("AddMotor and InitMotor OK"));
				MessageBox(MsgStr);

                btn_initial.EnableWindow(FALSE);

				combo_slot.EnableWindow(FALSE);
				combo_baud.EnableWindow(FALSE);
				combo_motorid.EnableWindow(FALSE);
				combo_motortype.EnableWindow(FALSE);

				slider_writepos.EnableWindow(TRUE);

				SetTimer(1, 100, NULL);
            }
		}
	}
}

void CTorqueControlDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: b[JzTBz`{XM () Isw]
	WORD ret;
	CString str_torque;
	long torque = 0;

	ret = CPMotor_PT_CurrentTorque(Slot, Id, &torque);
	if(ret == 0){
		str_torque.Format(_T("%d"),(short)torque);
		edit_readpos.SetWindowText(str_torque);
		slider_readpos.SetPos((short)(torque));
	}

	CDialog::OnTimer(nIDEvent);
}

void CTorqueControlDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: b[JzTBz`{XM () Isw]
	WORD ret;
	int tag_torque;
	CString str_torque;

	CSliderCtrl *pSliderCtrl = (CSliderCtrl *)GetDlgItem(IDC_SLIDER_WPOSI);
	tag_torque = pSliderCtrl->GetPos();
	str_torque.Format(_T("%ld"),tag_torque);

	edit_writepos.SetWindowTextW(str_torque);

	ret = CPMotor_PT_MotionMove(Slot, Id, abs(tag_torque/100), tag_torque);
	if(ret != 0){
		MsgStr.Format(_T("CPMotor_PT_MotionMove Error %d"), ret);
		MessageBox(MsgStr);
	}

	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}
